Fetch List of Server Devices

This API will fetch the list of server devices onboarded in AppViewX based on the status and vendor specified.

Before You Begin

Before attempting to fetch this list, ensure the following:
  • Devices should be added in the server device inventory.
  • Users should have permission of Platform > Asset Management > Device Inventory > Servers.
  • Users should have read permission to the added devices.

Request Structure

Endpoint: /certificates/devices/servers
Type: GET
Sample URL:
https://<IP/HostName/TenantName>:<GWPORT>/avxapi/certificates/devices/servers?vendor=Apache&status=Managed&page=3&limit=4&gwsource=external

To understand the elements of the sample URL, click here.

Headers
Content-Type: application/json
Table 1. Request Parameters
Name Description
sessionId or auth token

Header

(Mandatory if username and password are not provided) Session ID received after login.

Type: String

username

Header

(Mandatory if sessionId is not provided) AppViewX login username

Type: String

password

Header

(Mandatory if sessionId is not provided) AppViewX login password

Type: String

Content-Type

Header

Specifies the nature of the data in the payload

Type: String

Possible values: application/json

gwsource

Query

Source from which the request is triggered. (E.g. external)

Type: String

Payload

Body

Contains all the parameters to be sent in the request body for the post request

Type: Payload

Payload

Table 2. Payload
Name Description
vendor (Optional) Name of the server device vendor

Type: Sting

Possible values: For the full list of supported server device vendors, click here.

page (Optional) Starting page in the inventory to being the search

Type: Integer

Default value: 1

Constraints: Only positive integer values allowed

limit (Optional) Maximum number of records to be fetched (beginning from the starting page)

Type: Integer

Default value: 100

Constraints:
  • Only positive integer values allowed
  • Maximum limit value: 100
Status (Optional) Device status value to be included in the search query

Type: String

Constraints: The status should be a valid value.

Possible values:
  • Unresolved
  • Failed
  • InProgress
  • Managed
  • Queued

Response Structure

Success Response

200 OK response with the list of devices from the device inventory

Response content-type: application/json

Table 3. Response Parameters
Name Description
response Contains the response attributes for the fetch request

Type: response

message Success message of the action or failure description (in case of error)

Type: String

appStatusCode Application specific status code for the response. Will be non-null for failure response.

Type: String

tags More info in case of failure response

Type: String

Table 4. response
Name Description
credentialType Authentication mechanism used by AppViewX to access and managed privileged accounts

Type: String

Possible values: Manual entry, Credential list-AppViewX, SSH, etc.

hostName Unique name assigned to identify the device within the network

Type: String

operatingSystemType Operating system installed on the device

Type: String

fqdn IP address/Fully Qualified Domain Name of the device within the network

Type: String

dataCenter Data center where the device is hosted

Type: String

port Communication port of the device

Type: Integer

vendor Name of the device vendor

Type: String

name Device name used in AppViewX

Type: String

certSyncStatus Certificate parsing status

Type: String

version Device version number

Type: String

status Device status in AppViewX

Type: String

Possible values: Managed, Failed, Unresolved, etc.

Status Codes

Table 5. Status Codes
HTTP Status code appStatusCode Message and Possible Remediation
401 Unauthorized AVX_GW_003 Authentication failed, reason - Invalid Credentials

Possible remediation: Ensure that valid username and password or valid sessionId is provided as the header param.

403 Forbidden CERT-ACF-0058 User does not have access to the targeted API

Possible remediation: Ensure that the user has the required ACF permissions to export certificates for a given module.

407 Proxy Authentication Required AVX_GW_011 Session validation failed; reason: Session information is missing

Possible remediation: Provide correct authentication parameters.

400 Bad Request MISC_VAL_005 Invalid query param for 'xxx'

Possible remediation: Ensure that the field mentioned in the error message is assigned an accepted value.

Sample Request/Response

Sample Request
GET /avxapi/certificates/devices/servers?vendor=Apache&status=Managed&page=3&limit=4&gwsource=external
Sample Response
{
   "response": {
       "data": [
           {
               "credentialType": "Manual Entry",
               "hostName": null,
               "operatingSystemType": null,
               "fqdn": "pe-adc-apvx-n3.lab.appviewx.net",
               "dataCenter": "absecon",
               "port": 22,
               "vendor": "Apache",
               "name": "pe-adc-apvx-n3.lab.appviewx.net",
               "certSyncStatus": "Completed",
               "version": "",
               "status": "Managed"
           },
           {
               "credentialType": "Manual Entry",
               "hostName": null,
               "operatingSystemType": null,
               "fqdn": "pm-saas-node18.lab.appviewx.net",
               "dataCenter": null,
               "port": 22,
               "vendor": "Apache",
               "name": "pm-saas-node18.lab.appviewx.net",
               "certSyncStatus": "Completed",
               "version": "",
               "status": "Managed"
           }
       ],
       "iTotalDisplayRecords": 2
   },
   "message": null,
   "appStatusCode": null,
   "tags": null,
   "headers": null
}

References

Understanding the sample URL
  • IP/HostName/TenantName: Replace with the actual IP address, hostname, or tenant name based on the specific configuration in AppViewX.
    • IP: A unique identifier assigned to each device connected to a computer network that uses the Internet Protocol for communication

      The IP address will be included in the endpoint URL for an on-prem deployment.

    • HostName: A human-readable label assigned to a device (host) on a network

      The hostname will be included in the endpoint URL for an on-prem deployment.

    • TenantName: An identifier label for a tenant given to indicate which tenant's data the API request will access/modify

      The tenant name will be included in the endpoint URL for a SaaS deployment.

  • GWPORT: AppViewX gateway port

    A gateway port refers to a network port through which data is sent and received to communicate with a gateway in an on-prem deployment.

    Example: 31443

  • avxapi: Path parameter value (static) that is part of the endpoint's URL
  • Endpoint: Endpoint of the API, for example: execute-hook
  • gwsource: Source or origin of a gateway, for example: external.